Unit AMM9R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMM9R(var A :Array of Real; N :Integer; NCA :Integer;
                var B :Array of Real; NCB :Integer;
                var C :Array of Real); 
implementation

procedure AMM9R(var A :Array of Real; N :Integer; NCA :Integer;
                var B :Array of Real; NCB :Integer;
                var C :Array of Real);
var
NCAP1,NCAP2,NCBP1,NCBP2,NM1,NCC,ND,I,J,NBO,K,K1,NDMI,M,JPTA,JPTB,
   LEDZRA,LEDZRB,IRA,IRB,JCA,JCB :Integer;
SUM :Real;
label
_2,_5,_10,_15,_20,_25,_30,_35,_40,_45,_50,_52,_55,_60,_65;
begin
NCAP1 := NCA + 1;
NCAP2 := NCA + 2;
NCBP1 := NCB + 1;
NCBP2 := NCB + 2;
NM1 := N + N - 1;
NCC := 2 * (NCA+NCB) + 1;
NCC := Min0(NCC,NM1);
ND := (NCC+3) div 2;
for I:=1 to N do
 begin
  for K1:=1 to NCC do
   begin
    C[(I-1)+(K1-1)*N] := 0.0;
_2:
   end;
  NDMI := ND - I;
  M := Max0(1,NDMI);
  for J:=1 to N do
   begin
    if ( M > NCC )
     then goto _60;
    JPTA := 0;
    JPTB := 0;
    LEDZRA := NCAP2;
    LEDZRB := NCBP2;
    IRA := I;
    IRB := J;
    JCA := Max0(NCAP2-I,1);
    JCB := Max0(NCBP2-J,1);
    SUM := 0.0;
    for K:=1 to N do
     begin
      NBO := 0;
      if ( JCA = 0 ) 
       then goto _52;
      if ( I < LEDZRA ) 
       then goto _5;
      LEDZRA := LEDZRA + 1;
      if ( J < LEDZRB ) 
       then goto _35;
      LEDZRB := LEDZRB + 1;
      goto _50;
_5:
      if ( JCB = 0 ) 
       then goto _52;
      if ( J < LEDZRB ) 
       then goto _10;
      LEDZRB := LEDZRB + 1;
      NBO := 1;
      goto _15;
_10:
      SUM := SUM + A[(IRA-1)+(JCA-1)*N] * B[(IRB-1)+(JCB-1)*N];
_15:
      if ( JPTA <> 0 ) 
       then goto _20;
      if ( JCA < NCAP1 ) 
       then goto _25;
      JPTA := 1;
_20:
      JCA := JCA - 1;
      IRA := IRA + 1;
      goto _30;
_25:
      JCA := JCA + 1;
_30:
      if ( NBO = 1 ) 
       then goto _50;
_35:
      if ( JPTB <> 0 ) 
       then goto _40;
      if ( JCB < NCBP1 ) 
       then goto _45;
      JPTB := 1;
_40:
      JCB := JCB - 1;
      IRB := IRB + 1;
      goto _50;
_45:
      JCB := JCB + 1;
_50:
     end;
_52:
    if ( NDMI >= 1 )
     then goto _55;
    NDMI := NDMI + 1;
    goto _60;
_55:
    C[(I-1)+(M-1)*N] := SUM;
    M := M + 1;
_60:
   end;
_65:
 end;
end;

end.
